#ifndef _3DSURF_H_INCLUDED_
#define _3DSURF_H_INCLUDED_

//               -  /    
#define         SURF_NORMALS                    1
#define         SURF_COLORS                     2
#define         SURF_TEXCOORDS                  4
#define         SURF_FACENORMALS                8

struct          surface_t
{
  //                   -  =======
  //             ,   
  int           nvertices;
  //            
  vector_t      *vertex;
  //               ( )
  vector_t      *normal;
  //              (  )
  rgb_t         *color;
  //              (.  .  . )
  texcoord_t    *texcoord;
  //                   =======
  //              -    
  int           __nextvtx;
  //             ( ) 
  int           __validfields;
  //            ,     
  int           __drawfields;
  //              -    
  int           k;
  int           l;
  //               ( , . )
  vector_t      *facenormal;
  //            32 -  ,    
  int           Data32;
};

DECLSPEC        surfNew(struct surface_t *surf,int k,int l);
DECLSPEC        surfDelete(struct surface_t *surf);
DECLSPEC        surfAddVtx(struct surface_t *surf,vector_t *vtx,
                           vector_t *nrm,rgb_t *clr,texcoord_t *txc);
//                .   !!!
DECLSPEC        surfGenerateFaceNorms(struct surface_t *surf);
//              .   !!!   !!!
DECLSPEC        surfGenerateNorms(struct surface_t *surf);
//                .   !!!
DECLSPEC        surfNormalizeFNorms(struct surface_t *surf);
//                .   !!!
DECLSPEC        surfNormalizeNorms(struct surface_t *surf);
//                .   !!!
DECLSPEC        surfCalculateNormals(struct surface_t *surf);
DECLSPEC        surfGetBBox(struct surface_t *surf,
                            vector_t *min,vector_t *max);
DECLSPEC        surfSetBBox(struct surface_t *surf,vector_t *min,
                            vector_t *max);
DECLSPEC        surfTranslate(struct surface_t *surf,vector_t *tr);
DECLSPEC        surfScale(struct surface_t *surf,vector_t *sc);

#endif

