#ifndef ITOMODEL_H_INCLUDED
#define ITOMODEL_H_INCLUDED

#include "u_typedef.hpp"

//      ==================================================================
//            -   .
//             
//       'GetModuleVersionInfo'.     -
//      ,      .    
//             -
//      ,     -    
//       .
//          .
//           : " ",
//      ""  " ".      
//       .  " "   -
//        .     
//      "";  ,       
//       ,       -
//         . ,  "  -
//      "     -  .   
//        ,     .
//      23.11.99 -    MS C++
//      ==================================================================

//       =================================================================
//          ***      -   ***
//       =================================================================
//        -   -  
class    IAdden
{
public:
  //  
  virtual pchar __stdcall      Description(void)=0;
  //    
  virtual pchar __stdcall      StdName(void)=0;
  //     
  virtual pchar __stdcall      StdBName(void)=0;
  //      ,
  //     -   GetValue.
  virtual int   __stdcall      RequiredDimension(void)=0;
  //     M
  virtual void  __stdcall      Value(double *M,double *Res)=0;
};

typedef  IAdden *pIAdden;

//        -  -  
class    IModel
{
public:
  virtual pchar __stdcall      Description()=0;
  //      ,
  //     -   GetValue.
  virtual int   __stdcall      RequiredDimension(void)=0;
  //   
  virtual int   __stdcall      AddenCount()=0;
  //     
  virtual pIAdden __stdcall    Addens(int Index)=0;
  //     M   B
  virtual void  __stdcall      Value(double *M,double *B,double *Res)=0;
};

typedef  IModel *pIModel;

//        -  
class    IGenerator
{
public:
  virtual pchar __stdcall      Description()=0;
  //   ,    . 
  //  -  ,   -  .
  virtual void  __stdcall      RequiredDimensions(int *nRows,int *nCols)=0;
  //  .
  virtual void  __stdcall      Generate(double **Rows)=0;
  //    .
  virtual pIModel __stdcall    DefaultModel()=0;
};

typedef IGenerator *pIGenerator;

//           
typedef  int (__stdcall *GenericEnumProc)(pvoid lpObject);

#define ADENUM_OK       1
#define ADENUM_CANCEL   0
#define MODENUM_OK      1
#define MODENUM_CANCEL  0
#define PLENUM_OK       1
#define PLENUM_CANCEL   0

#pragma pack(push)
#pragma pack(2)
struct  ModuleVersionInfo
{
  word  wMinor,wMajor;
  char  *pszDescription;
};
#pragma pack(pop)

//       =================================================================
extern "C"
{
    //         
    int UEXPORT GetModuleVersionInfo(ModuleVersionInfo *lpVersionInfo);
    //        ,   
    int UEXPORT AddensEnumerate(GenericEnumProc EnumProc);
    int UEXPORT ModelsEnumerate(GenericEnumProc EnumProc);
    int UEXPORT GensEnumerate(GenericEnumProc EnumProc);
};

#endif  // ITOMODEL_H_INCLUDED
